<?php
class sbcApi {

	/*
	 * Functions name: please, follow the same nomenclature than sbcapi (nodejs server)
	 */

	public 	$socket 	= null,
		$socket_error	= '';

	private $_host = '127.0.0.1',
		$_port = '55542';

	private	$_sbc_conf 		= [],
		$_sbc_conf_path 	= '/etc/beroNet/sbc.conf',
		$_sbc_conf_parameters 	= [
			['php_key' => 'id', 'bash_key' => 'SBCVM_ID', 'regex' => '[0-9]+'],
		];

	private $_is_construct = false;

	function __construct() {
		// check sbc-api running
		if (!$this->_isSbcApiRunning()) {
			$this->socket_error = "SBC-API is not running";
			return;
		}

		// load sbc-conf file and set sbc-conf associative array
		if (!file_exists($this->_sbc_conf_path)) {
			return;
		}

		$sbc_conf = file_get_contents($this->_sbc_conf_path);	
		foreach ($this->_sbc_conf_parameters as $parameter) {
			if (preg_match('/'. $parameter['bash_key'] .'="('. $parameter['regex'] .')"/', $sbc_conf, $matched)) {
				$this->_sbc_conf[$parameter['php_key']] = $matched[1];
				unset($matched);
			}
			else {
				$this->_sbc_conf[$parameter['php_key']] = null;
			}
		}

		$this->_is_construct = true;
	}

	/* [PUBLIC METHODS] */

	public function getActionVpnServer(string $action, $options = []) {
		if (!$this->_is_construct) {
			return -1;
		}
		switch ($action) {
			case 'client':
				$uri = "/VPN/Server/{$this->_sbc_conf['id']}/{$action}";
				break;
			default:
				break;
		}
		return $this->_sendRequest($uri);
	}

	/* [PRIVATE METHODS] */
	
	private function _isSbcApiRunning() {
		try {
			$this->socket = @fsockopen($this->_host, $this->_port, $errno, $errstr, 1);
		}
		catch (Exception $e) {
			// todo
			return FALSE;
		}
		return $this->socket;
	}

	private function _sendRequest($uri, $data = null) {
		$api_url = "http://{$this->_host}:{$this->_port}$uri";
	
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $api_url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

		if (!is_null($data)) {
			// POST - PUT request
		}

		$response = curl_exec($ch);
		curl_close($ch);
		return $response;
	}
}
?>
